/*
** OpenGL_drawer.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Sat Jan 26 10:34:05 2008 damien
** Last update Sat Jan 26 10:34:05 2008 damien
*/

#ifndef   	OPENGL_DRAWER_H_
# define   	OPENGL_DRAWER_H_


#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
#include <GL/glut.h>
#include <GL/glext.h>
using namespace std;

#include <Navigator_tool.h>
#include <Mesh_object.h>
#include <Segment.h>
#include <Triangle.h>
#include <Polygon.h>
#include <Curve_3D.h>

#include <Skeleton.h>
#include <Texture.h>

class OpenGL_drawer
{

 public:

  OpenGL_drawer();
  ~OpenGL_drawer();


  int draw_mesh_slow(Mesh_object& mesh);
  int draw_mesh_grid(Mesh_object& mesh);
  int init_opengl(int arc,char **argv,const Navigator_tool& navigator);
  int draw_local_basis(Navigator_tool& navigator);

  int draw_segment(const Segment& s) const;
  int draw_triangle(const Triangle& t) const;
  int draw_polygon(const Polygon& p) const;
  int draw_curve(const Curve_3D& c) const;

  int draw_skeleton(Skeleton &);
  GLuint load_texture(const char* filename);
  
  int draw_selected_bone(Skeleton &skeleton,int selected_joint);

 private:
  
  std::vector <GLint> draw_list;
  
  std::vector <GLfloat> current_color;
  int set_current_color(int k_bone);
  
};

#endif 	    /* !OPENGL_DRAWER_H_ */
