#ifndef _Texture_h
#define _Texture_h

#include <stdlib.h>
#include <iostream>
#include <GL/glut.h>
#include <cmath>
#include <string>
#include <errno.h>
#include <string>
#include <GL/glext.h>
#include <stdio.h>

using namespace std;

#include <png.h> /* PNG library definitions */
#include <jpeglib.h> /* JPG library definitions */
#include <jerror.h>

#define MAX_SIZE_EXTENSION 15
//#define SIZE_BUFFER 100

#define NO_FORMAT  0
#define JPG_FORMAT 1
#define PNG_FORMAT 2



class Texture
{
 public:
  Texture();
  ~Texture();

  int load_picture(const char* file_name);
  int export_ppm(const char* file_name);

  int get_Nx();
  int get_Ny();
  int get_depth();
  unsigned char* get_data();

  int get_nearest_texel(float s_1,float s_2,float *texel);
  int get_linear_texel(float s_1,float s_2,float *texel);

 private:
  int load_png_picture(const char* file_name);
  int load_jpg_picture(const char* file_name);

  int destroy();

  int get_file_type(const char* filename);

  int N_x,N_y;
  unsigned char *picture;
  int depth;
};

#endif
